﻿/* =========================================================================
NAME: Rus2rus
VERSION: 1.1
AUTHOR: Vitaly Batushev
DATE  : 2.02.2010
SUPPORT: http://www.adobescripts.info
E-MAIL: vitaly@batushev.info
============================================================================ */
#targetengine session
win = "window { \
		properties:{resizeable: false, maximizeButton: false, text:'Rus2rus' }, \
		findPanel: Panel { orientation: 'row', alignChildren:['right', 'center'], text:'Find', margins:[10,20,10,10], \
				txt1: StaticText { text:'Prefix:' }, \
				e1: EditText { characters: 10, text:'^'}, \
				txt2: StaticText { text:'Suffix:' }, \
				e2: EditText { characters: 10}, \
		},\
		groupRB: Group { orientation: 'row', aligment:'left', alignChildren:['left', 'center'], \
				r1:RadioButton { text:'AБВ > абв', value:true }, \
				r2:RadioButton { text:'абв > АБВ', value:false }, \
		}, \
		groupBtn: Group {orientation: 'row', alignChildren:'right', \
			btnOK: Button {text:'Change', alignment:'center', properties:{name:'ok'}}, \
			btnCancel: Button { text:'Cancel', alignment:'center', properties:{name:'cancel'} }, \
		},\
	}";
if (app.documents.length == 0) {exit();}
var dlg= new Window (win);
dlgProcess(dlg); dlg.center(); dlg.show();
function dlgProcess(dlg) {
	ButtonOK = dlg.groupBtn.btnOK.onClick =  function() {
		var fp = dlg.findPanel.e1.text; var fs = dlg.findPanel.e2.text; var up =  dlg.groupRB.r1.value;
		dlg.close();
		if (app.selection.length == 0 )  { 
			r2r(app.activeDocument, fp, fs, up); 
		} else { 
			switch (app.selection[0].constructor.name) {
				case 'Text':
				case 'Word':
				case 'TextColumn':
					var myObj = app.selection[0]; break;
				case 'TextFrame':
					var myObj = app.selection[0].parentStory; break;
				default:
					var myObj = app.activeDocument; break;
			}
			r2r(myObj, fp, fs, up);
		}		
	}
	dlg.groupBtn.btnCancel.onClick =  function() { dlg.close(); }
}
function r2r(processObject, findPrefix, findSuffix, upSw) {
	app.findGrepPreferences = null; app.changeGrepPreferences = null;
	if (upSw) {
		app.findGrepPreferences.findWhat = findPrefix + '[А-ЯЁ]' + findSuffix;
	} else {
		app.findGrepPreferences.findWhat = findPrefix + '[А-яё]' + findSuffix;
	}
	var f = processObject.findGrep();
	if (f != null) {
		for (ff = 0; ff < f.length; ff++) {
			if (upSw) { f[ff].changecase(ChangecaseMode.LOWERCASE); } else { f[ff].changecase(ChangecaseMode.UPPERCASE); }
		}
	}
	app.findGrepPreferences = null; app.changeGrepPreferences = null;
}